#ifndef RWSIM_FUNCTIONS_H
#define RWSIM_FUNCTIONS_H

#include <vector>
#include <array>
#include <utility>
#include <chrono>


int nearest_index(const std::vector<double>&, double, int);

double lerp(const std::vector<double>&, const std::vector<double>&, double, int);

std::array<double, 3> spherical_to_xyz(double, double);

std::pair<double, double> xyz_to_spherical(const std::array<double, 3>& xyz);

std::chrono::time_point<std::chrono::system_clock> printSteps(std::chrono::time_point<std::chrono::system_clock>, std::chrono::time_point<std::chrono::system_clock>, int, int);

#endif
